diff -crB mplp_ver2/mplp_alg.cpp mplp_ver2.src-patched/mplp_alg.cpp
*** mplp_ver2/mplp_alg.cpp	2012-08-08 20:25:06.000000000 +0200
--- mplp_ver2.src-patched/mplp_alg.cpp	2014-02-25 10:05:55.000000000 +0100
***************
*** 797,808 ****
  		double smallest_gap = huge;
  		int index_smallest = -1;
  		for (std::set<int>::iterator s_it = not_decoded.begin(); s_it != not_decoded.end(); ++s_it){
  			if( ( gap_vals[*s_it] = gap(*s_it, m) ) < smallest_gap) {
  				smallest_gap = gap_vals[*s_it];
  				index_smallest = *s_it;
  			}else if (gap_vals[*s_it] == smallest_gap){
  				if (rand() % 2){   //some randomness for tied nodes (but this may still not be uniform)
! 				  if(DEBUG_MODE)
  				    cout << "Adding some randomness to globaldecoding2" << endl;
  				  index_smallest = *s_it;
  				}
--- 806,818 ----
  		double smallest_gap = huge;
  		int index_smallest = -1;
  		for (std::set<int>::iterator s_it = not_decoded.begin(); s_it != not_decoded.end(); ++s_it){
+ 		   int m;
  			if( ( gap_vals[*s_it] = gap(*s_it, m) ) < smallest_gap) {
  				smallest_gap = gap_vals[*s_it];
  				index_smallest = *s_it;
  			}else if (gap_vals[*s_it] == smallest_gap){
  				if (rand() % 2){   //some randomness for tied nodes (but this may still not be uniform)
! 				  if(MPLP_DEBUG_MODE)
  				    cout << "Adding some randomness to globaldecoding2" << endl;
  				  index_smallest = *s_it;
  				}
***************
*** 813,819 ****
  		if(!exhaustive && smallest_gap > GAP_THR)
  		  break;
  
! 		if(DEBUG_MODE)
  		  cout << "Fixing node " << index_smallest << " to value " << max_at[index_smallest] << endl;
  
  		// Fix one at a time
--- 823,829 ----
  		if(!exhaustive && smallest_gap > GAP_THR)
  		  break;
  
! 		if(MPLP_DEBUG_MODE)
  		  cout << "Fixing node " << index_smallest << " to value " << max_at[index_smallest] << endl;
  
  		// Fix one at a time
***************
*** 828,835 ****
  		  m_sum_into_intersects[index_smallest][i] = -huge;
  		}
  
! 		for (int it=0; it<10; ++it){
! 		  for (int ri=0; ri<m_all_regions.size(); ++ri){
  		    m_all_regions[ri].UpdateMsgs(m_sum_into_intersects);
  		  }
  		  num_mplp_iters_global_decoding++;
--- 838,845 ----
  		  m_sum_into_intersects[index_smallest][i] = -huge;
  		}
  
! 		for (size_t it=0; it<10; ++it){
! 		  for (size_t ri=0; ri<m_all_regions.size(); ++ri){
  		    m_all_regions[ri].UpdateMsgs(m_sum_into_intersects);
  		  }
  		  num_mplp_iters_global_decoding++;
***************
*** 839,865 ****
  		  UpdateResult();
  		}
  
! 		//		if(DEBUG_MODE){
  		//		  cout << "new int sol = " << m_best_val << endl;
  		//		}
  
  		// Give up after 100 rounds (1000 total MPLP iterations)
  		if(!exhaustive && num_mplp_iters_global_decoding >= 1000) {
  
! 		  if(DEBUG_MODE)
  		    cout << "Exhausted number of rounds for global decoding. Quitting." << endl;
  		  break;
  		}
  	}
! 	for (int i = 0; i < m_all_regions.size(); ++i){
! 		for (int j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  			for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				m_all_regions[i].m_msgs_from_region[j].m_dat[k] = tmp_msgs[i][j][k];
  			}
  		}
  	}
! 	for (i = 0; i < m_sum_into_intersects.size(); ++i){
! 		for (j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			m_sum_into_intersects[i].m_dat[j] = tmp_sums[i][j];
  		}
  	}
--- 849,875 ----
  		  UpdateResult();
  		}
  
! 		//		if(MPLP_DEBUG_MODE){
  		//		  cout << "new int sol = " << m_best_val << endl;
  		//		}
  
  		// Give up after 100 rounds (1000 total MPLP iterations)
  		if(!exhaustive && num_mplp_iters_global_decoding >= 1000) {
  
! 		  if(MPLP_DEBUG_MODE)
  		    cout << "Exhausted number of rounds for global decoding. Quitting." << endl;
  		  break;
  		}
  	}
! 	for (size_t i = 0; i < m_all_regions.size(); ++i){
! 		for (size_t j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  			for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  				m_all_regions[i].m_msgs_from_region[j].m_dat[k] = tmp_msgs[i][j][k];
  			}
  		}
  	}
! 	for (size_t i = 0; i < m_sum_into_intersects.size(); ++i){
! 		for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  			m_sum_into_intersects[i].m_dat[j] = tmp_sums[i][j];
  		}
  	}
***************
*** 877,899 ****
  // Do large numbers of random objective permutations, run 10 iterations of MPLP, restore
  void MPLPAlg::RunGlobalDecoding3(void){
  
!   if(DEBUG_MODE) {
      cout << "Running global decoding3..." << endl;
    }
  
    //saving current mplp state
    std::vector< std::vector< std::vector<double> > > tmp_msgs;
    std::vector< std::vector<double> > tmp_sums;
!   for (int i = 0; i < m_all_regions.size(); ++i){
      tmp_msgs.push_back(std::vector< std::vector<double> >());
!     for (int j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
        tmp_msgs[i].push_back(std::vector<double>());
        for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  	tmp_msgs[i][j].push_back(m_all_regions[i].m_msgs_from_region[j].m_dat[k]);
        }
      }
    }
!   for (int i = 0; i < m_sum_into_intersects.size(); ++i){
      tmp_sums.push_back(std::vector<double>());
      for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
        tmp_sums[i].push_back(m_sum_into_intersects[i].m_dat[j]);
--- 887,909 ----
  // Do large numbers of random objective permutations, run 10 iterations of MPLP, restore
  void MPLPAlg::RunGlobalDecoding3(void){
  
!   if(MPLP_DEBUG_MODE) {
      cout << "Running global decoding3..." << endl;
    }
  
    //saving current mplp state
    std::vector< std::vector< std::vector<double> > > tmp_msgs;
    std::vector< std::vector<double> > tmp_sums;
!   for (size_t i = 0; i < m_all_regions.size(); ++i){
      tmp_msgs.push_back(std::vector< std::vector<double> >());
!     for (size_t j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
        tmp_msgs[i].push_back(std::vector<double>());
        for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  	tmp_msgs[i][j].push_back(m_all_regions[i].m_msgs_from_region[j].m_dat[k]);
        }
      }
    }
!   for (size_t i = 0; i < m_sum_into_intersects.size(); ++i){
      tmp_sums.push_back(std::vector<double>());
      for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
        tmp_sums[i].push_back(m_sum_into_intersects[i].m_dat[j]);
***************
*** 903,909 ****
    // Do large numbers of random objective permutations, run 4 iterations of MPLP, restore
    for(int trial=0; trial <= 10; trial++) {
   
!     for(int si=0; si < m_var_sizes.size(); ++si) {
        // Randomly perturb single node potentials
        for(int loc=0; loc < m_sum_into_intersects[si].m_n_prodsize; loc++) {
  	// TODO: how to set the scale?  perhaps look at objective value.
--- 913,919 ----
    // Do large numbers of random objective permutations, run 4 iterations of MPLP, restore
    for(int trial=0; trial <= 10; trial++) {
   
!     for(size_t si=0; si < m_var_sizes.size(); ++si) {
        // Randomly perturb single node potentials
        for(int loc=0; loc < m_sum_into_intersects[si].m_n_prodsize; loc++) {
  	// TODO: how to set the scale?  perhaps look at objective value.
***************
*** 921,934 ****
      RunGlobalDecoding2(exhaustive);
  
      // Restoring MPLP state
!     for (int i = 0; i < m_all_regions.size(); ++i){
!       for (int j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  	for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  	  m_all_regions[i].m_msgs_from_region[j].m_dat[k] = tmp_msgs[i][j][k];
  	}
        }
      }
!     for (int i = 0; i < m_sum_into_intersects.size(); ++i){
        for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  	m_sum_into_intersects[i].m_dat[j] = tmp_sums[i][j];
        }
--- 931,944 ----
      RunGlobalDecoding2(exhaustive);
  
      // Restoring MPLP state
!     for (size_t i = 0; i < m_all_regions.size(); ++i){
!       for (size_t j = 0; j < m_all_regions[i].m_msgs_from_region.size(); ++j){
  	for (int k = 0; k < m_all_regions[i].m_msgs_from_region[j].m_n_prodsize; ++k){
  	  m_all_regions[i].m_msgs_from_region[j].m_dat[k] = tmp_msgs[i][j][k];
  	}
        }
      }
!     for (size_t i = 0; i < m_sum_into_intersects.size(); ++i){
        for (int j = 0; j < m_sum_into_intersects[i].m_n_prodsize; ++j){
  	m_sum_into_intersects[i].m_dat[j] = tmp_sums[i][j];
        }
***************
*** 945,954 ****
  	int *max_at = new int[m_var_sizes.size()];
  	double *gap_vals = new double[m_var_sizes.size()];
  	std::vector<int> not_decoded;
! 	if(DEBUG_MODE) {
  		cout << "Running decimation..." << endl;
  	}
! 	for (int i = 0; i < m_var_sizes.size(); ++i){
  		if (evidence.find(i) == evidence.end()){
  			not_decoded.push_back(i);
  		}
--- 955,964 ----
  	int *max_at = new int[m_var_sizes.size()];
  	double *gap_vals = new double[m_var_sizes.size()];
  	std::vector<int> not_decoded;
! 	if(MPLP_DEBUG_MODE) {
  		cout << "Running decimation..." << endl;
  	}
! 	for (size_t i = 0; i < m_var_sizes.size(); ++i){
  		if (evidence.find(i) == evidence.end()){
  			not_decoded.push_back(i);
  		}
***************
*** 957,963 ****
  		if( ( gap_vals[*s_it] = gap(*s_it, m) ) >= biggest_gap){
  			biggest_gap = gap_vals[*s_it];
  		}
! 		if(DEBUG_MODE) {
  		  //		  cout << "gap " << gap_vals[*s_it] << endl;
  		}
  		max_at[*s_it] = m;
--- 967,973 ----
  		if( ( gap_vals[*s_it] = gap(*s_it, m) ) >= biggest_gap){
  			biggest_gap = gap_vals[*s_it];
  		}
! 		if(MPLP_DEBUG_MODE) {
  		  //		  cout << "gap " << gap_vals[*s_it] << endl;
  		}
  		max_at[*s_it] = m;
***************
*** 967,973 ****
  	for (std::vector<int>::iterator s_it = not_decoded.begin(); s_it != not_decoded.end(); ++s_it){
  		if (gap_vals[*s_it] >= biggest_gap){   //gap stores argmax of reparametrized local potential in max_at
  
! 		  //		  if(DEBUG_MODE) {
  		  //		    cout << "Fixing node " << *s_it << endl;
  		  //		  }
  		  fixed_node = true;
--- 977,983 ----
  	for (std::vector<int>::iterator s_it = not_decoded.begin(); s_it != not_decoded.end(); ++s_it){
  		if (gap_vals[*s_it] >= biggest_gap){   //gap stores argmax of reparametrized local potential in max_at
  
! 		  //		  if(MPLP_DEBUG_MODE) {
  		  //		    cout << "Fixing node " << *s_it << endl;
  		  //		  }
  		  fixed_node = true;
Only in mplp_ver2: ._mplp_alg.h
diff -crB mplp_ver2/mplp_alg.h mplp_ver2.src-patched/mplp_alg.h
*** mplp_ver2/mplp_alg.h	2012-08-08 20:25:06.000000000 +0200
--- mplp_ver2.src-patched/mplp_alg.h	2014-02-25 10:05:55.000000000 +0100
***************
*** 6,12 ****
   *  Copyright 2008 MIT. All rights reserved.
   *
   */
! using namespace std;
  #include <vector>
  #include <iostream>
  #include <fstream>
--- 6,15 ----
   *  Copyright 2008 MIT. All rights reserved.
   *
   */
! 
! #ifndef MPLP_MPLP_ALG_H
! #define MPLP_MPLP_ALG_H
! 
  #include <vector>
  #include <iostream>
  #include <fstream>
***************
*** 23,51 ****
  {
  public:
  	// The variables in the region
! 	vector<int> m_region_inds;
  
  	// Specifies the indices of the intersection sets
! 	vector<int> m_intersect_inds;
  
  	// Specifies the indices corresponding to the position of each
  	// intersection set in the region
! 	vector<vector<int> > m_inds_of_intersects;
  
  	// Every region has a corresponding intersection set. What is its index?
  	int m_region_intersect;
  
  	// Contains the messages from each region to its intersection sets
! 	vector<MulDimArr> m_msgs_from_region;
! 	vector<int> m_var_sizes; 
  	
! 	Region(vector<int> & region_inds, vector<vector<int> > & all_intersects, vector<int> & intersect_inds, vector<int> & var_sizes, int region_intersect);
  	
  	// Adds intersection set to the region
! 	void AddIntersectionSet(int intersect_loc, vector<vector<int> > & all_intersects, vector<int> & var_sizes);
  
! 	void UpdateMsgs(vector<MulDimArr> & sum_into_intersects);
! 	int Get_nVars() {return m_var_sizes.size();};
  };
  
  class MPLPAlg
--- 26,54 ----
  {
  public:
  	// The variables in the region
!    std::vector<int> m_region_inds;
  
  	// Specifies the indices of the intersection sets
!    std::vector<int> m_intersect_inds;
  
  	// Specifies the indices corresponding to the position of each
  	// intersection set in the region
!    std::vector<std::vector<int> > m_inds_of_intersects;
  
  	// Every region has a corresponding intersection set. What is its index?
  	int m_region_intersect;
  
  	// Contains the messages from each region to its intersection sets
! 	std::vector<MulDimArr> m_msgs_from_region;
! 	std::vector<int> m_var_sizes;
  	
! 	Region(const std::vector<int> & region_inds, const std::vector<std::vector<int> > & all_intersects, const std::vector<int> & intersect_inds, const std::vector<int> & var_sizes, int region_intersect);
  	
  	// Adds intersection set to the region
! 	void AddIntersectionSet(int intersect_loc, std::vector<std::vector<int> > & all_intersects, std::vector<int> & var_sizes);
  
! 	void UpdateMsgs(std::vector<MulDimArr> & sum_into_intersects);
! 	size_t Get_nVars() {return m_var_sizes.size();};
  };
  
  class MPLPAlg
***************
*** 68,109 ****
  	double last_global_decoding_total_time;
  
  	bool m_uaiCompetition;
! 	vector<vector<int> > m_all_intersects;
! 	vector<Region> m_all_regions;
  	//	vector<vector<int> > m_all_region_inds;
! 	vector<MulDimArr> m_sum_into_intersects;
  	//	vector<MulDimArr> m_all_lambdas;
  	//	vector<vector<int> > m_all_region_intersects;
  	std::map<int, int> evidence;
! 	vector<int> m_var_sizes;
! 	vector<int> m_decoded_res;
! 	vector<int> m_best_decoded_res;
! 	vector<double> m_objhist;
! 	vector<double> m_inthist;
! 	vector<double> m_timehist;
! 	vector<MulDimArr> m_single_node_lambdas;
! 	vector<MulDimArr> m_region_lambdas;
  
  	// Is this a CSP instance?
  	bool CSP_instance;
  
  	// This map allows us to quickly look up the index of edge intersection sets
! 	map<pair<int, int>, int> m_intersect_map;
  
  	//create an MPLP instance from the model file and evidence file (if any)
  	MPLPAlg(clock_t, int, const std::string, const std::string, FILE *, bool uaiCompetition); 
  
  	MPLPAlg(void){};     //for decoding purpose only
  
  	void Init(const std::string, const std::string = "");
  	
  	void Init2(const std::string, const std::string = "");
  
! 	void Init(vector<int> & var_sizes, vector<vector<int> > & all_region_inds, vector<vector<double> > & all_lambdas);
  
  	void RunMPLP(int, double, double);
  
! 	double IntVal(vector<int> & assignment) const;
  
  	double gap(int, int &) const;
  
--- 71,115 ----
  	double last_global_decoding_total_time;
  
  	bool m_uaiCompetition;
! 	std::vector<std::vector<int> > m_all_intersects;
! 	std::vector<Region> m_all_regions;
  	//	vector<vector<int> > m_all_region_inds;
! 	std::vector<MulDimArr> m_sum_into_intersects;
  	//	vector<MulDimArr> m_all_lambdas;
  	//	vector<vector<int> > m_all_region_intersects;
  	std::map<int, int> evidence;
! 	std::vector<int> m_var_sizes;
! 	std::vector<int> m_decoded_res;
! 	std::vector<int> m_best_decoded_res;
! 	std::vector<double> m_objhist;
! 	std::vector<double> m_inthist;
! 	std::vector<double> m_timehist;
! 	std::vector<MulDimArr> m_single_node_lambdas;
! 	std::vector<MulDimArr> m_region_lambdas;
  
  	// Is this a CSP instance?
  	bool CSP_instance;
  
  	// This map allows us to quickly look up the index of edge intersection sets
! 	std::map<std::pair<int, int>, int> m_intersect_map;
  
  	//create an MPLP instance from the model file and evidence file (if any)
  	MPLPAlg(clock_t, int, const std::string, const std::string, FILE *, bool uaiCompetition); 
  
+    // create an MPLP instance from the model given by var_sizes, all_factors and all_lambdas
+    MPLPAlg(clock_t, int, const std::vector<int>&, const std::vector< std::vector<int> >&, const std::vector< std::vector<double> >&, FILE *, bool uaiCompetition);
+ 
  	MPLPAlg(void){};     //for decoding purpose only
  
  	void Init(const std::string, const std::string = "");
  	
  	void Init2(const std::string, const std::string = "");
  
! 	void Init(const std::vector<int> & var_sizes, const std::vector<std::vector<int> > & all_region_inds, const std::vector<std::vector<double> > & all_lambdas);
  
  	void RunMPLP(int, double, double);
  
! 	double IntVal(std::vector<int> & assignment) const;
  
  	double gap(int, int &) const;
  
***************
*** 117,133 ****
  
  	// Add a new region and return its index. intersect_inds refers to the index of the intersection sets that this
  	// region intersects with (that is, the index into m_all_intersects)
! 	int AddRegion(vector<int> & inds_of_vars, vector<int> & intersect_inds);
  	// As in the Matlab code, for now we will assume that an intersetion set is added before adding the regions that
  	// intersect with it
! 	int AddIntersectionSet(vector<int> & inds_of_vars);
  
  	// For regions of size >2, remove single node intersection sets and add all edge intersection sets
  	void AddAllEdgeIntersections();
  
  	// Find the index number into m_all_intersects of a given set of variables' intersection set.
  	// Returns -1 if not found.
! 	int FindIntersectionSet(vector<int> & inds_of_vars);
  	
  	void Write(const char *res_fname, const char *msgs_fname = "msgs.txt", const char *suminto_fname = "suminto.txt", const char *objhist_fname = "objhist.txt", const char *inthist_fname = "inthist.txt", const char *timehist_fname = "timehist.txt");
  private:
--- 123,139 ----
  
  	// Add a new region and return its index. intersect_inds refers to the index of the intersection sets that this
  	// region intersects with (that is, the index into m_all_intersects)
! 	int AddRegion(std::vector<int> & inds_of_vars, std::vector<int> & intersect_inds);
  	// As in the Matlab code, for now we will assume that an intersetion set is added before adding the regions that
  	// intersect with it
! 	int AddIntersectionSet(std::vector<int> & inds_of_vars);
  
  	// For regions of size >2, remove single node intersection sets and add all edge intersection sets
  	void AddAllEdgeIntersections();
  
  	// Find the index number into m_all_intersects of a given set of variables' intersection set.
  	// Returns -1 if not found.
! 	int FindIntersectionSet(std::vector<int> & inds_of_vars);
  	
  	void Write(const char *res_fname, const char *msgs_fname = "msgs.txt", const char *suminto_fname = "suminto.txt", const char *objhist_fname = "objhist.txt", const char *inthist_fname = "inthist.txt", const char *timehist_fname = "timehist.txt");
  private:
***************
*** 140,142 ****
--- 146,150 ----
  	double LocalDecode(void);      //single node decoding
  	double UpdateResult(void);   //returns primal objective of this mplp instance
  };
+ 
+ #endif
Only in mplp_ver2: ._muldim_arr.cpp
diff -crB mplp_ver2/muldim_arr.h mplp_ver2.src-patched/muldim_arr.h
*** mplp_ver2/muldim_arr.h	2012-08-08 20:25:06.000000000 +0200
--- mplp_ver2.src-patched/muldim_arr.h	2014-02-25 10:05:55.000000000 +0100
***************
*** 6,20 ****
   *  Copyright 2008 MIT. All rights reserved.
   *
   */
! using namespace std;
  #include <vector>
  #include <iostream>
! #include "matrix.h"
! #include <string.h> 
! 
! #ifndef _MULDIMARR
! #define _MULDIMARR
  
  
  #define huge 1e40
  #define BASE2DEC_PAIR(x1,x2,base1,base2) (x1*base2+x2)
--- 6,20 ----
   *  Copyright 2008 MIT. All rights reserved.
   *
   */
! 
! #ifndef MPLP__MULDIM_ARR_h
! #define MPLP__MULDIM_ARR_h
! 
  #include <vector>
  #include <iostream>
! #include <string.h>
  
+ #include "matrix.h"
  
  #define huge 1e40
  #define BASE2DEC_PAIR(x1,x2,base1,base2) (x1*base2+x2)
***************
*** 22,34 ****
  class MulDimArr 
  {
  public:
! 	vector<int> m_base_sizes;
  	int m_n_prodsize;
  	double *m_dat;
  	double *m_ep;
  	
  	// Initialize to all zero
! 	MulDimArr(vector<int> & base_sizes); 
  	
  	// Copy constructor
  	MulDimArr(const MulDimArr & v);
--- 22,34 ----
  class MulDimArr 
  {
  public:
! 	std::vector<int> m_base_sizes;
  	int m_n_prodsize;
  	double *m_dat;
  	double *m_ep;
  	
  	// Initialize to all zero
! 	MulDimArr(std::vector<int> & base_sizes);
  	
  	// Copy constructor
  	MulDimArr(const MulDimArr & v);
***************
*** 53,91 ****
  	const double & operator[](int i) const {return m_dat[i];}
  	double Max(int &max_at) const;
  	double Entropy(void) const;
! 	double Entropy_over_free_variables(const vector<int> &, const vector<int> &) const;
  	void print(void) const;
  	void print_with_inds(void) const;
! 	void Write(ofstream & ofs);
! 	void Read(ifstream & ifs);
  	
! 	inline int GetFlatInd(vector<int> & base_inds) const;
! 	inline int GetFlatIndFromBig(vector<int> big_base_inds, vector<int> inds_in_big) const;
! 	int GetFlatIndFromBigSpecial(vector<int> & big_base_inds, vector<int> & inds_in_big) const;
! 
! 	double GetVal(vector<int> & indices) const;
! 	MulDimArr Expand(vector<int> & var_sizes_big, vector<int> & inds_in_big);
! 	void ExpandAndAdd(MulDimArr & big_to_add_to, vector<int> & inds_of_small_in_big);
! 	void ExpandAndSubtract(MulDimArr & big_to_add_to, vector<int> & inds_of_small_in_big);
! 
! 	inline void BaseInc(vector<int> & inds) const;
! 	inline void BaseIncSpecial(vector<int> & inds) const;
! 
! 	void GetInds(int, vector<int> &) const;    //for decoding purposes
! 
! 	void  max_into_multiple_subsets_special(vector<vector<int> > & all_subset_inds, vector<MulDimArr> & all_maxes) const;
! 	double max_over_free_variables(const vector<int> &, vector<int> &) const;
! 	double gap_over_free_variables(const vector<int> &, vector<int> &, double &, double &) const;
  private:
! 	double _max_over_free_variables(int, int, int, int, const vector<int> &, vector<int> &) const;
! 	void _Entropy_over_free_variables(int, int, int, int, const vector<int> &, const vector<int> &, double &, double &) const;
  };
  
  // Return the index in the flat multi-dimensional array corresponding to
  // the given multi-index
  // NOTE: Since this function is called to get an intersection index out of a big index,
  // as long as we don't use intersections of more than two, we only need the cases given here.
! inline int MulDimArr::GetFlatIndFromBigSpecial(vector<int> & big_base_inds, vector<int> & inds_in_big) const{
  	int y,ind1,ind2;
  	
  	switch (inds_in_big.size())
--- 53,91 ----
  	const double & operator[](int i) const {return m_dat[i];}
  	double Max(int &max_at) const;
  	double Entropy(void) const;
! 	double Entropy_over_free_variables(const std::vector<int> &, const std::vector<int> &) const;
  	void print(void) const;
  	void print_with_inds(void) const;
! 	void Write(std::ofstream & ofs);
! 	void Read(std::ifstream & ifs);
  	
! 	inline int GetFlatInd(std::vector<int> & base_inds) const;
! 	inline int GetFlatIndFromBig(std::vector<int> big_base_inds, std::vector<int> inds_in_big) const;
! 	int GetFlatIndFromBigSpecial(std::vector<int> & big_base_inds, std::vector<int> & inds_in_big) const;
! 
! 	double GetVal(std::vector<int> & indices) const;
! 	MulDimArr Expand(std::vector<int> & var_sizes_big, std::vector<int> & inds_in_big);
! 	void ExpandAndAdd(MulDimArr & big_to_add_to, std::vector<int> & inds_of_small_in_big);
! 	void ExpandAndSubtract(MulDimArr & big_to_add_to, std::vector<int> & inds_of_small_in_big);
! 
! 	inline void BaseInc(std::vector<int> & inds) const;
! 	inline void BaseIncSpecial(std::vector<int> & inds) const;
! 
! 	void GetInds(int, std::vector<int> &) const;    //for decoding purposes
! 
! 	void  max_into_multiple_subsets_special(std::vector<std::vector<int> > & all_subset_inds, std::vector<MulDimArr> & all_maxes) const;
! 	double max_over_free_variables(const std::vector<int> &, std::vector<int> &) const;
! 	double gap_over_free_variables(const std::vector<int> &, std::vector<int> &, double &, double &) const;
  private:
! 	double _max_over_free_variables(int, int, int, int, const std::vector<int> &, std::vector<int> &) const;
! 	void _Entropy_over_free_variables(int, int, int, int, const std::vector<int> &, const std::vector<int> &, double &, double &) const;
  };
  
  // Return the index in the flat multi-dimensional array corresponding to
  // the given multi-index
  // NOTE: Since this function is called to get an intersection index out of a big index,
  // as long as we don't use intersections of more than two, we only need the cases given here.
! inline int MulDimArr::GetFlatIndFromBigSpecial(std::vector<int> & big_base_inds, std::vector<int> & inds_in_big) const{
  	int y,ind1,ind2;
  	
  	switch (inds_in_big.size())
***************
*** 100,112 ****
  			y = BASE2DEC_PAIR(big_base_inds[ind1],big_base_inds[ind2],m_base_sizes[0],m_base_sizes[1]);
  			break;
  		default:
! 			cout << "GetFlatIndFromBigSpecial problem" << endl;
  			break;
  	}
  	return y;
  }
  
! inline void MulDimArr::BaseIncSpecial(vector<int> & inds) const{
  	switch (inds.size())
  	{
  		case 1:
--- 100,112 ----
  			y = BASE2DEC_PAIR(big_base_inds[ind1],big_base_inds[ind2],m_base_sizes[0],m_base_sizes[1]);
  			break;
  		default:
! 		   std::cout << "GetFlatIndFromBigSpecial problem" << std::endl;
  			break;
  	}
  	return y;
  }
  
! inline void MulDimArr::BaseIncSpecial(std::vector<int> & inds) const{
  	switch (inds.size())
  	{
  		case 1:
Only in mplp_ver2: ._no.evid
Only in mplp_ver2: ._README
Only in mplp_ver2: ._read_model_file.cpp
